// Author: A.Voss@FH-Aachen.de
//
// idea
// tags: printf


// content: usage of templates, generic programming
//     new: template, vector, set, map, unordered_map, stl

// here some overview is given:
//     http://www.cplusplus.com/reference/stl/

#include <iostream>
#include <cstdlib>
#include <string>
#include <map>          // containers are part of the so-called 
#include <set>          // standard-template-library STL
#include <unordered_map>
using namespace std;

#include "../../include/tools.h"

int main()
{
    // an ordered set of ints, usually implemented as bin-tree
    set<int> s = { 1,2,3 };
    s.insert(4);
    s.insert(0);
    s.insert(2);    // exists
    
    tools_log(); cout << "loop with 'foreach':" << endl;
    for (int n : s)    // C++11-feature
    {
        tools_log(); cout << "   n = " << n << endl;
    }
    
    bool b1 = (s.find(1)!=s.end());
    bool b5 = (s.find(5)!=s.end());
    tools_log(); cout << "found 1: " << b1 << ", found 5: " << b5 << endl;
    
    // a dictionary, mapping a string to an int, implemented as tree
    map<string,int> m = { {"Aachen",241} };
    tools_log(); cout << "found Aachen: " << m["Aachen"] << ", Koeln: " << m["Koeln"] << endl;
    
    // also a dictionary, mapping a string to an int, implemented as a hash map
    unordered_map<string,int> h = { {"Maier",123456}, {"Mueller",987654} };
    tools_log(); cout << "found Maier: " << h["Maier"] << endl;

    return EXIT_SUCCESS;
}

